<template>
  <v-dialog
    v-bind="$attrs"
    :max-width="maxWidth"
    persistent
    v-on="$listeners"
  >
    <template
      v-if="activator"
      v-slot:activator="{ on, attrs }"
    >
      <slot
        name="activator"
        v-bind="attrs"
        v-on="on"
      >
        <div class="d-flex">
          <v-spacer />
          <v-btn
            v-bind="attrs"
            color="primary"
            v-on="on"
          >
            {{ $t('add') }}
          </v-btn>
        </div>
      </slot>
    </template>
    <v-card>
      <v-card-title>
        <p class="text-h5">
          {{ dialogTitle }}
        </p>
      </v-card-title>
      <v-card-subtitle>
        <p class="ma-0">
          {{ dialogSubtitle }}
        </p>
      </v-card-subtitle>
      <v-card-text>
        <slot />
      </v-card-text>
      <v-card-actions>
        <v-spacer />
        <cancel-btn
          :disabled="loading"
          @click="$emit('onClose', $event)"
        />
        <confirm-btn
          :loading="loading"
          :disabled="loading"
          @click="$emit('onSave', $event)"
        />
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script>
  export default {
    name: 'CrudDataTableFormDialog',
    props: {
      loading: {
        type: Boolean,
        required: false,
        default: false,
      },
      dialogTitle: {
        type: String,
        required: true,
      },
      dialogSubtitle: {
        type: String,
        required: true,
      },
      maxWidth: {
        type: String,
        required: false,
        default: '600px',
      },
      activator: {
        type: Boolean,
        required: false,
        default: true,
      },
    },
    i18n: {
      messages: {
        'pt-BR': {
          add: 'Adicionar',
        },
        'en-US': {
          add: 'Add',
        },
      },
    },
  }
</script>
